
#include "dxstdafx.h"
//#include "Params.h"
#include "Cube.h"

#define D3DFVF_CUSTOMVERTEX			(D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_TEX1)

struct Vertex
{
	float x, y, z;
	float nx, ny, nz;
	float tu, tv;
};

Cube::Cube(IDirect3DDevice9* pd3dDevice)
{
	this->pd3dDevice = pd3dDevice;
	
	//pVertexBuffer

	int vertexCnt = 24;
	float s = 1;	// igazbl mindegy a mret, mert csak a kocka sklzdik vele
	
	Vertex g_quadVertices[] =
	{
		// 1 lap = 2 hromszgbl ll triangle_strip
		// lapok krljrsi irnynak megvltoztatsa: a kzps 2 vertex felcserlsvel

		//x  y  z	 normal		texcoord
		{-s, s, s,   0,0,-1,	0,0 },
		{-s,-s, s,   0,0,-1,	0,1 },
		{ s, s, s,   0,0,-1,	1,0 },
		{ s,-s, s,   0,0,-1,	1,1 },

		// z rtk -1-szeres + 2. s 3. vertex cserje
		{-s, s, -s,   0,0,1,	0,0 },
		{ s, s, -s,   0,0,1,	1,0 },
		{-s,-s, -s,   0,0,1,	0,1 },
		{ s,-s, -s,   0,0,1,	1,1 },

		// y,z csere
		{-s,-s, s,    0,1,0,	0,0 },
		{-s,-s, -s,   0,1,0,	0,1 },
		{ s,-s, s,    0,1,0,	1,0 },
		{ s,-s, -s,   0,1,0,	1,1 },

		{-s, s, s,   0,-1,0,	0,0 },
		{ s, s, s,   0,-1,0,	1,0 },
		{-s, s,-s,   0,-1,0,	0,1 },
		{ s, s,-s,   0,-1,0,	1,1 },

		// x,z csere
		{-s, s,-s,    1,0,0,	0,0 },
		{-s,-s,-s,    1,0,0,	0,1 },
		{-s, s, s,    1,0,0,	1,0 },
		{-s,-s, s,    1,0,0,	1,1 },

		{ s, s, -s,  -1,0,0,	0,0 },
		{ s, s,  s,  -1,0,0,	1,0 },
		{ s,-s, -s,  -1,0,0,	0,1 },
		{ s,-s,  s,  -1,0,0,	1,1 },
	};

	pd3dDevice->CreateVertexBuffer( vertexCnt*sizeof(Vertex), D3DUSAGE_WRITEONLY, 
									D3DFVF_CUSTOMVERTEX, D3DPOOL_DEFAULT, 
									&pVertexBuffer, NULL );
	void *pVertices = NULL;

	pVertexBuffer->Lock( 0, sizeof(g_quadVertices), (void**)&pVertices, 0 );
	memcpy( pVertices, g_quadVertices, sizeof(g_quadVertices) );
	pVertexBuffer->Unlock();
}

void Cube::PrepareDrawing()
{
	pd3dDevice->SetStreamSource( 0, pVertexBuffer, 0, sizeof(Vertex) );
	pd3dDevice->SetFVF( D3DFVF_CUSTOMVERTEX );
}

void Cube::DrawFace(int index)
{
	pd3dDevice->DrawPrimitive( D3DPT_TRIANGLESTRIP, 4*index, 2 ); // startVertex, primitiveCnt
}

void Cube::Draw()
{
	for (int index = 0; index < 6; index++)
		pd3dDevice->DrawPrimitive( D3DPT_TRIANGLESTRIP, 4*index, 2 ); // startVertex, primitiveCnt
}
